/*
 * Copyright (c) 2015, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.carbon.registry.extensions.handlers.utils;

public class SwaggerConstants {


	//Swagger key constants
	public static final String SWAGGER_VERSION_12 = "1.2";
	public static final String SWAGGER_VERSION_2 = "2.0";

	//common swagger constants
	public static final String INFO = "info";
	public static final String DESCRIPTION = "description";
	public static final String NAME = "name";
	public static final String REQUIRED = "required";
	public static final String VERSION = "version";
	public static final String BASE_PATH = "basePath";

	//swagger 1.2 constants
	public static final String SWAGGER_VERSION_KEY = "swaggerVersion";
	public static final String API_VERSION = "apiVersion";
	public static final String APIS = "apis";
	public static final String OPERATIONS = "operations";
	public static final String TYPE = "type";
	public static final String METHOD = "method";


	//swagger 2.0 constants
	public static final String SWAGGER2_VERSION_KEY = "swagger";
	public static final String TITLE = "title";
	public static final String PATH = "path";
	public static final String SCHEMES = "schemes";
	public static final String PATHS = "paths";
	public static final String HOST = "host";
}
